        PAGE    79,124
        TITLE
CODE    SEGMENT
        ASSUME  CS:CODE, DS:CODE
        ORG     100H
START:
;
;  Get the floppy drive name from the command line
;
        MOV     BX,82h                    ;Location of drive parm
        MOV     AL,BYTE PTR [BX]
        CMP     AL,'A'                    ;If lower case convert to upper
        JL      CASEOK
        AND     AL,0CFh
CASEOK: CMP     AL,'A'                    ;Allow drives A and B only
        JE      DRIVEOK
        CMP     AL,'B'
        JE      DRIVEOK
        JMP     HELP

DRIVEOK:
        SUB     AL,65
        MOV     SDRIVE,AL                 ;Drive A = 0, Drive B = 1
        MOV     AH,9
        MOV     DX,OFFSET MESSAGE
        INT     21h
        MOV     AH,8
        INT     21h
;
;  Start of the first patch
;
        MOV     RETRY_COUNT,5
PATCH1:
        MOV     DL,SDRIVE
        MOV     AH,00
        INT     13h                       ;BIOS Diskette reset

        MOV     DL,SDRIVE                 ;Drive number
        MOV     DH,00                     ;Head number
        MOV     CL,01                     ;Sector number
        MOV     CH,01                     ;Cylinder
        MOV     BX,OFFSET THEEND          ;Buffer
        PUSH    DS
        POP     ES
        MOV     AL,01                     ;1 Sector
        MOV     AH,02                     ;Read
        INT     13h
        JNC     TEST_DATA1                ;OK

        DEC     RETRY_COUNT
        CMP     RETRY_COUNT,0
        JNE     PATCH1
        JMP     READERROR

TEST_DATA1:                               ;Test the data to be changed
        MOV     CX,6
        MOV     SI,OFFSET PPATCH1
        MOV     DI,OFFSET THEEND
        ADD     DI,016Ch
        PUSH    DI
        REPE    CMPSB
        POP     DI
        JE      MAKE_PATCH1
        JMP     NOTFOUND

MAKE_PATCH1:                              ;Make the patch if OK
        MOV     CX,2
        MOV     SI,OFFSET PPATCH1A
        REPZ    MOVSB

        MOV     RETRY_COUNT,5
WRITE_PATCH1:
        MOV     DL,SDRIVE
        MOV     AH,00
        INT     13h                       ;BIOS Diskette reset

        MOV     DL,SDRIVE                 ;Drive number
        MOV     DH,00                     ;Head number
        MOV     CL,01                     ;Sector number
        MOV     CH,01                     ;Cylinder
        MOV     BX,OFFSET THEEND          ;Buffer
        MOV     AL,01                     ;1 Sector
        MOV     AH,03                     ;Write
        INT     13h
        JNC     PATCH2A                   ;OK

        DEC     RETRY_COUNT
        CMP     RETRY_COUNT,0
        JNE     WRITE_PATCH1
        JMP     WRITEERROR

;
;  Start of the second patch
;
PATCH2A:
        MOV     RETRY_COUNT,5
PATCH2:
        MOV     DL,SDRIVE
        MOV     AH,00
        INT     13h                       ;BIOS Diskette reset

        MOV     DL,SDRIVE                 ;Drive number
        MOV     DH,01                     ;Head number
        MOV     CL,08                     ;Sector number
        MOV     CH,02                     ;Cylinder
        MOV     BX,OFFSET THEEND          ;Buffer
        PUSH    DS
        POP     ES
        MOV     AL,01                     ;1 Sector
        MOV     AH,02                     ;Read
        INT     13h
        JNC     TEST_DATA2                ;OK

        DEC     RETRY_COUNT
        CMP     RETRY_COUNT,0
        JNE     PATCH2
        JMP     READERROR

TEST_DATA2:                               ;Test the data to be changed
        MOV     CX,6
        MOV     SI,OFFSET PPATCH2
        MOV     DI,OFFSET THEEND
        ADD     DI,01F5h
        PUSH    DI
        REPE    CMPSB
        POP     DI
        JE      MAKE_PATCH2
        JMP     NOTFOUND

MAKE_PATCH2:                              ;Make the patch if OK
        MOV     CX,2
        MOV     SI,OFFSET PPATCH2A
        REPZ    MOVSB

        MOV     RETRY_COUNT,5
WRITE_PATCH2:
        MOV     DL,SDRIVE
        MOV     AH,00
        INT     13h                       ;BIOS Diskette reset

        MOV     DL,SDRIVE                 ;Drive number
        MOV     DH,01                     ;Head number
        MOV     CL,08                     ;Sector number
        MOV     CH,02                     ;Cylinder
        MOV     BX,OFFSET THEEND          ;Buffer
        MOV     AL,01                     ;1 Sector
        MOV     AH,03                     ;Write
        INT     13h
        JNC     PATCH3A                   ;OK

        DEC     RETRY_COUNT
        CMP     RETRY_COUNT,0
        JNE     WRITE_PATCH2
        JMP     WRITEERROR

;
;  Start of the third patch
;
PATCH3A:
        MOV     RETRY_COUNT,5
PATCH3:
        MOV     DL,SDRIVE
        MOV     AH,00
        INT     13h                       ;BIOS Diskette reset

        MOV     DL,SDRIVE                 ;Drive number
        MOV     DH,00                     ;Head number
        MOV     CL,01                     ;Sector number
        MOV     CH,03                     ;Cylinder
        MOV     BX,OFFSET THEEND          ;Buffer
        PUSH    DS
        POP     ES
        MOV     AL,01                     ;1 Sector
        MOV     AH,02                     ;Read
        INT     13h
        JNC     TEST_DATA3                ;OK

        DEC     RETRY_COUNT
        CMP     RETRY_COUNT,0
        JNE     PATCH3
        JMP     READERROR

TEST_DATA3:                               ;Test the data to be changed
        MOV     CX,7
        MOV     SI,OFFSET PPATCH3
        MOV     DI,OFFSET THEEND
        ADD     DI,0012h
        PUSH    DI
        REPE    CMPSB
        POP     DI
        JE      MAKE_PATCH3
        JMP     NOTFOUND

MAKE_PATCH3:                              ;Make the patch if OK
        MOV     CX,2
        MOV     SI,OFFSET PPATCH3A
        REPZ    MOVSB

        MOV     RETRY_COUNT,5
WRITE_PATCH3:
        MOV     DL,SDRIVE
        MOV     AH,00
        INT     13h                       ;BIOS Diskette reset

        MOV     DL,SDRIVE                 ;Drive number
        MOV     DH,00                     ;Head number
        MOV     CL,01                     ;Sector number
        MOV     CH,03                     ;Cylinder
        MOV     BX,OFFSET THEEND          ;Buffer
        MOV     AL,01                     ;1 Sector
        MOV     AH,03                     ;Write
        INT     13h
        JNC     PATCH4A                   ;OK

        DEC     RETRY_COUNT
        CMP     RETRY_COUNT,0
        JNE     WRITE_PATCH3
        JMP     WRITEERROR


;
;  Start of the fourth patch
;
PATCH4A:
        MOV     RETRY_COUNT,5
PATCH4:
        MOV     DL,SDRIVE
        MOV     AH,00
        INT     13h                       ;BIOS Diskette reset

        MOV     DL,SDRIVE                 ;Drive number
        MOV     DH,01                     ;Head number
        MOV     CL,04                     ;Sector number
        MOV     CH,06                     ;Cylinder
        MOV     BX,OFFSET THEEND          ;Buffer
        PUSH    DS
        POP     ES
        MOV     AL,01                     ;1 Sector
        MOV     AH,02                     ;Read
        INT     13h
        JNC     TEST_DATA4                ;OK

        DEC     RETRY_COUNT
        CMP     RETRY_COUNT,0
        JNE     PATCH4
        JMP     READERROR

TEST_DATA4:                               ;Test the data to be changed
        MOV     CX,6
        MOV     SI,OFFSET PPATCH4
        MOV     DI,OFFSET THEEND
        ADD     DI,0054h
        PUSH    DI
        REPE    CMPSB
        POP     DI
        JE      MAKE_PATCH4
        JMP     NOTFOUND

MAKE_PATCH4:                              ;Make the patch if OK
        MOV     CX,2
        MOV     SI,OFFSET PPATCH4A
        REPZ    MOVSB

        MOV     RETRY_COUNT,5
WRITE_PATCH4:
        MOV     DL,SDRIVE
        MOV     AH,00
        INT     13h                       ;BIOS Diskette reset

        MOV     DL,SDRIVE                 ;Drive number
        MOV     DH,01                     ;Head number
        MOV     CL,04                     ;Sector number
        MOV     CH,06                     ;Cylinder
        MOV     BX,OFFSET THEEND          ;Buffer
        MOV     AL,01                     ;1 Sector
        MOV     AH,03                     ;Write
        INT     13h
        JNC     EXIT                      ;OK

        DEC     RETRY_COUNT
        CMP     RETRY_COUNT,0
        JNE     WRITE_PATCH4
        JMP     WRITEERROR

READERROR:
        MOV     AH,9
        MOV     DX,OFFSET READERRMSG
        INT     21h
        JMP     EXIT

NOTFOUND:
        MOV     AH,9
        MOV     DX,OFFSET NOTFOUNDMSG
        INT     21h
        JMP     EXIT

WRITEERROR:
        MOV     AH,9
        MOV     DX,OFFSET WRITEERRMSG
        INT     21h
        JMP     EXIT

HELP:
        MOV     AH,9
        MOV     DX,OFFSET HELPMSG
        INT     21h
        JMP     EXIT

EXIT:
        MOV     AX,4C00h                  ;Return to DOS
        INT     21h

MESSAGE         DB  13,10,13,10
                DB  'Please put a DISKCOPY of "Pirates!" into the drive',13,10,
                DB  'and press a key ...',13,10,'$'
HELPMSG         DB  13,10,'SYNTAX:',13,10,13,10
                DB  'PPATCH [<drive:>]',13,10,'$'
READERRMSG      DB  13,10
                DB  'Disk read error.',13,10,'$'
NOTFOUNDMSG     DB  'Sorry - Unable to patch this disk.',13,10,'$'
WRITEERRMSG     DB  13,10
                DB  'Disk write error.',13,10,'$'
CRLF            DB  13,10,'$'
PPATCH1         DB  073h,00Eh,0FFh,0Eh,002h,00h
PPATCH1A        DB  0EBh,035h
PPATCH2         DB  073h,009h,0FFh,0Eh,040h,14h
PPATCH2A        DB  0EBh,00Eh
PPATCH3         DB  074h,005h,0C6h,06h,03Dh,47h,04h
PPATCH3A        DB  0EBh,005h
PPATCH4         DB  073h,00Eh,0FFh,0Eh,0FEh,16h
PPATCH4A        DB  0EBh,038h
SDRIVE          DB  00
RETRY_COUNT     DW  0

THEEND  LABEL   BYTE
CODE    ENDS
        END     START
